///home/berryj/link/bin/genMethods "-g" "-t" "HyperGraph" "-r" "MHyperGraph" "-I" "LINK/graph/HyperGraph.h" "-y" "display_graph" "-w" "free_graph" "-d" "graph" "-f" "___hyperGraph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/HyperGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graph(SCM, SCM, int);
void free_graph(SCM);

typedef HyperGraph _HyperGraph;

#define _HyperGraphDATA(x) ((HyperGraph*) (EXTDATA(x)))
#define _HyperGraphIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<HyperGraph >::type))
#define _HyperGraphISNT_DATA(x) (!_HyperGraphIS_DATA(x))

#define _HyperGraphCXX_DATA(x) (*(HyperGraph*) (EXTDATA(VAL(x))))
#define _HyperGraphCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<HyperGraph >::type))
#define _HyperGraphCXX_ISNT_DATA(x) (!_HyperGraphCXX_IS_DATA(x))


PRIMITIVE STk_init____hyperGraph()
{
	Wrapper<_HyperGraph>::type = STk_new_CXXwrapper_id(
			Wrapper<_HyperGraph>::name, 
			Wrapper<MHyperGraph >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graph,
			(void (*)(SCM x))0,
			(void (*)(SCM x))free_graph);
	Tcl_InitHashTable(&Register<_HyperGraph>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra___hyperGraphMethods(void);

PRIMITIVE STk_init_methods____hyperGraph()
{
	genExtra___hyperGraphMethods();
	return UNDEFINED;
}
